//
//  FusePowerNetwork.m
//  SampleApp
//
//  Created by Pokkt on 13/11/15.
//  Copyright © 2015 Pokkt. All rights reserved.
//

#import "FusePowerNetwork.h"
#import "FuseSDK.h"
#import "PokktNetworkDelegate.h"
#import "NetworkModel.h"

@implementation FusePowerNetwork

@synthesize networkName;

static bool isInitialized;
UIViewController *playerVC;
NetworkModel *network;
static NSString *appID;
static NSString *zoneID;

- (void)initNetwork:(PokktConfig *)pokktConfig networkModel:(NetworkModel *)customData
presentingViewController:(UIViewController *)viewController
{
    if (isInitialized) {
        return;
    }
    self.pokktConfig = pokktConfig;
    playerVC = viewController;
    network = customData;
    appID = @"a206acef-4e31-437b-94a1-caa1515d24e0";//[customData.customData objectForKey:@"appId"];
    zoneID = @"708d4565";//[customData.customData objectForKey:@"zoneId"];
    
    [FuseSDK startSession: appID delegate:self withOptions:nil];
    
    isInitialized = YES;
    NSLog(@"[FuseSDK] FusePowered Initialised");
}

- (void)cacheVideo
{
    NSString *str = nil;
    if ([FuseSDK isAdAvailableForZoneID:zoneID]) {
        str = @"[FuseSDK] FusePowered video were already saved in cached";
        [PokktNetworkDelegate didFinishedVideoDownload:self.pokktConfig networkModel:network rewardValue:0 downLoadTime:@""];
    }
    else
    {
        [PokktNetworkDelegate didFailedVideoDownload:self.pokktConfig networkModel:network errorMessage:@"Ads not available!!"];
        str = @"[FuseSDK] FusePowered video is not available right now!!";
    }
    
    NSLog(@"%@",str);
}

- (void)playVideo
{
    [FuseSDK showAdForZoneID:zoneID options:
     @{ kFuseRewardedAdOptionKey_ShowPreRoll: @YES
        ,kFuseRewardedAdOptionKey_ShowPostRoll: @NO
        ,kFuseRewardedOptionKey_PreRollYesButtonText: @"I want it!" }
     ];
}

-(void) sessionStartReceived
{
    [FuseSDK preloadAdForZoneID:zoneID];
    NSLog(@"[FuseSDK] FusePowered Session Started");
}

-(void) adAvailabilityResponse:(NSNumber*)_available Error:(NSError*)_error
{
    BOOL isAvailable = [_available boolValue];
    
    if (isAvailable) {
        NSLog(@"[FuseSDK] Video became available in background !!");
    }else{
        NSLog(@"[FuseSDK] Video is not available in background !!");
    }
}

-(void) rewardedAdCompleteWithObject:(FuseRewardedObject*) _reward
{
    [PokktNetworkDelegate onVideoCompleted:self.pokktConfig networkModel:network];
    [PokktNetworkDelegate onVideoGratified:self.pokktConfig networkModel:network rewardPoint:_reward.rewardAmount.floatValue];
    
    NSLog(@"[FuseSDK] FusePowered Video downloaded");
}

-(void) adDidShow:(NSNumber *)_networkID mediaType:(NSNumber *)_mediaType
{
    [PokktNetworkDelegate onVideoDisplayed:self.pokktConfig networkModel:network];
    NSLog(@"[FuseSDK] FusePowered Video displayed");
}

-(void) adWillClose
{
    [PokktNetworkDelegate onVideoClosed:self.pokktConfig networkModel:network];
    NSLog(@"[FuseSDK] FusePowered Video closed");
}

-(void) sessionLoginError:(NSError*)_error
{
    NSLog(@"%@",_error.description);
}
@end
